/*
ngWebCrypto
---
The MIT License (MIT)

copyright ©2016 Giancarlo A. Chiappe Aguilar

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in 
the Software without restriction, including without limitation the rights to 
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies 
of the Software, and to permit persons to whom the Software is furnished to do 
so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all 
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE 
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE 
SOFTWARE.
---
©2016 Giancarlo Chiappe Aguilar <gchiappe@outlook.com.pe>
*/
"use strict";var NgWebCryptoUtils=function(){function e(){this.ABtoString=function(e){for(var t="",n=0;n<e.byteLength;n++)t+=String.fromCharCode(e[n]);return t},this.ABtoUTF8String=function(e){return new TextDecoder("utf-8").decode(e)},this.StringToBase64Url=function(e){return btoa(e).replace(/\+/g,"-").replace(/\//g,"_").replace(/\=+$/,"")},this.Base64UrlToString=function(e){return e=(e+"===").slice(0,e.length+e.length%4),e=e.replace(/-/g,"+").replace(/_/g,"/"),atob(e)},this.StringtoAB=function(e){for(var t=new Uint8Array(e.length),n=0;n<e.length;n++)t[n]=e.charCodeAt(n);return t},this.UTF8StringtoAB=function(e){return new TextEncoder("utf-8").encode(e)},this.isFunction=function(e){return!!(e&&e.constructor&&e.call&&e.apply)},this.isDefined=function(e){return void 0!==e&&null!==e},this.ABToHS=function(e){if(!e)return"";for(var t="",n=0;n<e.length;n++){var r=(255&e[n]).toString(16);r=1===r.length?"0"+r:r,t+=r}return t.toUpperCase()},this.HSToAB=function(e){if(!e)return new Uint8Array;for(var t=[],n=0,r=e.length;n<r;n+=2)t.push(parseInt(e.substr(n,2),16));return new Uint8Array(t)}}return e}(),webCryptoConstants={class:{ECDH:"ECDH",AESGCM:"AES-GCM"},namedCurve:{P128:"P-128",P256:"P-256",P521:"P-521"},format:{RAW:"raw",JWK:"jwk",HS:"HS"},type:{PRIVATE:"private",PUBLIC:"public",MIXED:"mixed"}};angular.module("ngWebCrypto",[]),angular.module("ngWebCrypto").provider("$webCrypto",["$injector",function(e){var t=this,n=window.crypto;if(!n.subtle)throw"ng-web-crypto: browser not supported.";var r=e.instantiate(NgWebCryptoUtils),i=[],a=[],o=function(e){for(var t=0;t<i.length;t++)if(i[t].name==e)return i[t];return-1},s=function(e){for(var t=0;t<a.length;t++)if(a[t].name==e)return a[t];return-1},u=null,c=null;this.generateKey=function(e){var t=new Promise(function(t,a){r.isDefined(e.random)&&e.random&&(e.name=r.ABToHS(n.getRandomValues(new Uint8Array(12)))),r.isDefined(e.name)||a("key name is required for generating."),-1!=o(e.name)&&a("key name "+e.name+" already in use."),r.isDefined(e.namedCurve)||(e.namedCurve=webCryptoConstants.namedCurve.P256),r.isDefined(e.type)||(e.type=webCryptoConstants.type.PRIVATE),e.type!=webCryptoConstants.type.PRIVATE&&e.type!=webCryptoConstants.type.PUBLIC&&e.type!=webCryptoConstants.type.MIXED&&a("invalid key type (private, public, mixed)."),n.subtle.generateKey({name:webCryptoConstants.class.ECDH,namedCurve:e.namedCurve},!0,["deriveKey","deriveBits"]).then(function(s){n.subtle.exportKey(webCryptoConstants.format.JWK,s.publicKey).then(function(c){n.subtle.exportKey(webCryptoConstants.format.RAW,s.publicKey).then(function(n){i.push({class:webCryptoConstants.class.ECDH,type:e.type,name:e.name,key:s,jwk:c,raw:n}),-1!=o(e.name)?(r.isDefined(u)||(u=e.name),t(e.name)):a("key was not added to storage.")})})}).catch(function(e){a(e)})});return t.success=function(e){return t.then(function(t){e(t)}),t},t.error=function(e){return t.then(null,function(t){e(t)}),t},t},this.getDefaultKeys=function(){return{ecdh:u,crypto:c}},this.checkKey=function(e){return-1!=o(e)},this.checkCryptoKey=function(e){return-1!=s(e)},this.importKey=function(e){var y=new Promise(function(y,f){r.isDefined(e.name)||f("key name is required for importing."),t.checkKey(e.name)&&f('key name "',e.name,'" already in use.'),r.isDefined(e.class)||(e.class=webCryptoConstants.class.ECDH),r.isDefined(e.crv)||(e.crv=webCryptoConstants.namedCurve.P256),r.isDefined(e.format)||(e.format=webCryptoConstants.format.RAW),r.isDefined(e.type)||(e.type=webCryptoConstants.type.PUBLIC);var d=void 0,p=void 0,l=[];e.format==webCryptoConstants.format.JWK?e.class==webCryptoConstants.class.ECDH?(r.isDefined(e.x)&&r.isDefined(e.y)&&r.isDefined(e.d)||f("x, y and d parameters are required to import an ECDH key."),d={kty:"EC",crv:e.crv,x:e.x,y:e.y,d:e.d,ext:!0},p={name:webCryptoConstants.class.ECDH,namedCurve:e.crv},e.type==webCryptoConstants.type.PRIVATE&&(l=["deriveKey","deriveBits"])):e.class==webCryptoConstants.class.AESGCM?(r.isDefined(e.k)||f("k parameter is required to import an AES-GCM key (k paramter must be HexString encoded)."),d={kty:"oct",k:r.StringToBase64Url(r.ABtoString(r.HSToAB(e.k))),alg:"A256GCM",ext:!0},p={name:webCryptoConstants.class.AESGCM},l=["encrypt","decrypt"]):f("unsupported crypto class "+e.class):(r.isDefined(e.raw)||f("raw parameter is missing."),d=r.HSToAB(e.raw),e.class==webCryptoConstants.class.ECDH?p={name:webCryptoConstants.class.ECDH,namedCurve:e.crv}:e.class==webCryptoConstants.class.AESGCM?p={name:webCryptoConstants.class.AESGCM}:f("unsupported crypto class")),n.subtle.importKey(e.format,d,p,!0,l).then(function(t){n.subtle.exportKey("jwk",t).then(function(d){n.subtle.exportKey("raw",t).then(function(n){e.class==webCryptoConstants.class.AESGCM?(a.push({class:e.class,type:e.type,name:e.name,key:{publicKey:t},jwk:d,raw:n}),-1!=s(e.name)?(r.isDefined(c)||(c=e.name),y(e.name)):f("key was not added to storage.")):(i.push({class:e.class,type:e.type,name:e.name,key:{publicKey:t},jwk:d,raw:n}),-1!=o(e.name)?(r.isDefined(u)||(u=e.name),y(e.name)):f("key was not added to storage."))})})}).catch(function(e){f(e)})});return y.success=function(e){return y.then(function(t){e(t)}),y},y.error=function(e){return y.then(null,function(t){e(t)}),y},y},this.exportKey=function(e){if(r.isDefined(e.default)&&e.default){if(!r.isDefined(u))throw"default key is not defined.";e.name=u}if(!r.isDefined(e.name))throw"key name is required for exporting keys.";var t=o(e.name);if(-1==t)throw"Key "+e.name+" not found.";if(r.isDefined(e.type)||(e.type=webCryptoConstants.format.RAW),e.type==webCryptoConstants.format.JWK){if(r.isDefined(t.jwk))return t.jwk;throw"the key "+e.name+" cannot be exported."}if(e.type==webCryptoConstants.format.RAW){if(r.isDefined(t.raw))return r.ABToHS(new Uint8Array(t.raw));throw"the key "+e.name+" cannot be exported."}throw"invalid export type"},this.deriveBits=function(e){var t=new Promise(function(t,i){r.isDefined(e.privateKeyName)&&r.isDefined(e.publicKeyName)||i("deriving bits require two previously stored keys.");var a=o(e.privateKeyName),s=o(e.publicKeyName);-1==a&&i("private key "+e.privateKeyName+" not found."),-1==s&&i("public key "+e.publicKeyName+" not found."),a.type!=webCryptoConstants.type.MIXED&&(a.type!=webCryptoConstants.type.PRIVATE&&i("key "+e.privateKeyName+" is not a valid private key."),s.type!=webCryptoConstants.type.PUBLIC&&i("key "+e.publicKeyName+" is not a valid public key.")),r.isDefined(e.bits)||(e.bits=256),r.isDefined(e.format)||(e.format="HS"),r.isDefined(e.namedCurve)||(e.namedCurve=webCryptoConstants.namedCurve.P256),n.subtle.deriveBits({name:webCryptoConstants.class.ECDH,namedCurve:e.namedCurve,public:s.key.publicKey},a.key.privateKey,e.bits).then(function(e){new Uint8Array(e);t(r.ABToHS(new Uint8Array(e)))}).catch(function(e){i(e)})});return t.success=function(e){return t.then(function(t){e(t)}),t},t.error=function(e){return t.then(null,function(t){e(t)}),t},t},this.deriveKey=function(e){var t=new Promise(function(t,i){r.isDefined(e.name)||i("key name is required for deriving ECDH keys."),-1!=s(e.name)&&i("key name "+e.name+" already in use."),r.isDefined(e.privateKeyName)&&r.isDefined(e.publicKeyName)||i("deriving keys require two previously stored keys.");var u=o(e.privateKeyName),y=o(e.publicKeyName);-1==u&&i("private key "+e.privateKeyName+" not found."),-1==y&&i("public key "+e.publicKeyName+" not found."),u.type!=webCryptoConstants.type.MIXED&&(u.type!=webCryptoConstants.type.PRIVATE&&i("key "+e.privateKeyName+" is not a valid private key."),y.type!=webCryptoConstants.type.PUBLIC&&i("key "+e.publicKeyName+" is not a valid public key.")),r.isDefined(e.targetClass)||(e.targetClass=webCryptoConstants.class.AESGCM),r.isDefined(e.targetLength)||(e.targetLength=256),r.isDefined(e.namedCurve)||(e.namedCurve=webCryptoConstants.namedCurve.P256),r.isDefined(e.exportable)||(e.exportable=!1),n.subtle.deriveKey({name:webCryptoConstants.class.ECDH,namedCurve:e.namedCurve,public:y.key.publicKey},u.key.privateKey,{name:e.targetClass,length:e.targetLength},e.exportable,["encrypt","decrypt"]).then(function(o){o={publicKey:o},e.exportable?n.subtle.exportKey("jwk",o.publicKey).then(function(u){n.subtle.exportKey("raw",o.publicKey).then(function(n){a.push({class:e.targetClass,type:"private",name:e.name,key:o,jwk:u,raw:n}),-1!=s(e.name)?(r.isDefined(c)||(c=e.name),t(e.name)):i("key was not added to storage.")})}).catch(function(e){console.error("error exporting derived key: ",e,"."),i(e)}):(a.push({class:e.targetClass,type:"private",name:e.name,key:o,jwk:null,raw:null}),-1!=s(e.name)?(r.isDefined(c)||(c=e.name),t(e.name)):i("key was not added to storage."))}).catch(function(e){i(e)})});return t.success=function(e){return t.then(function(t){e(t)}),t},t.error=function(e){return t.then(null,function(t){e(t)}),t},t},this.encrypt=function(e){var t=new Promise(function(t,i){r.isDefined(e.default)&&e.default&&(r.isDefined(c)?e.name=c:i("default key is not defined.")),r.isDefined(e.name)||i("crypto key name is required for encrypting data."),r.isDefined(e.data)||i("data option must be defined and not null."),-1==s(e.name)&&i("Key "+e.name+" not found."),"ECDH"==s(e.name).class&&i("Key "+e.name+" is not valid for encryption"),r.isDefined(e.tagLength)||(e.tagLength=128);var a=n.getRandomValues(new Uint8Array(12));n.subtle.encrypt({name:s(e.name).class,iv:a,tagLength:e.tagLength},s(e.name).key.publicKey,r.UTF8StringtoAB(e.data)).then(function(e){var n={encrypted:r.ABToHS(new Uint8Array(e)),iv:r.ABToHS(a)};t(n)}).catch(function(e){i(e)})});return t.success=function(e){return t.then(function(t){e(t.encrypted,t.iv)}),t},t.error=function(e){return t.then(null,function(t){e(t)}),t},t},this.decrypt=function(e){var t=new Promise(function(t,i){r.isDefined(e.default)&&e.default&&(r.isDefined(c)?e.name=c:i("default key is not defined.")),r.isDefined(e.name)||i("key name is required for decrypting."),r.isDefined(e.iv)||i("the iv is required for decrypting."),r.isDefined(e.data)||i("data option must be defined and not null."),-1==s(e.name)&&i("Key "+e.name+" not found."),"ECDH"==s(e.name).class&&i("Key "+e.name+" is not valid for encryption."),r.isDefined(e.tagLength)||(e.tagLength=128),n.subtle.decrypt({name:s(e.name).class,iv:r.HSToAB(e.iv),tagLength:e.tagLength},s(e.name).key.publicKey,r.HSToAB(e.data)).then(function(e){var n={decrypted:r.ABtoUTF8String(new Uint8Array(e))};t(n)}).catch(function(e){i(e)})});return t.success=function(e){return t.then(function(t){e(t.decrypted)}),t},t.error=function(e){return t.then(null,function(t){e(t)}),t},t},this.$get=function(){return{tools:{ArrayBufferToHexString:function(e){return r.ABToHS(e)},HexStringToArrayBuffer:function(e){return r.HSToAB(e)},ArrayBufferToString:function(e){return r.ABtoString(e)},StringToArrayBuffer:function(e){return r.StringtoAB(e)}},generate:function(e){return t.generateKey(e)},generateWithSeed:function(e){return t.importKey({name:r.ABToHS(n.getRandomValues(new Uint8Array(12))),k:e,class:webCryptoConstants.class.AESGCM,format:webCryptoConstants.format.JWK})},import:function(e){return t.importKey({name:r.ABToHS(n.getRandomValues(new Uint8Array(12))),raw:e})},importAndDeriveWithDefaultKey:function(e){var i=t,a=i.getDefaultKeys(),o=r.ABToHS(n.getRandomValues(new Uint8Array(12))),s=r.ABToHS(n.getRandomValues(new Uint8Array(12))),u=new Promise(function(t,n){r.isDefined(a.ecdh)||n("No default ECDH key defined."),i.importKey({name:o,raw:e}).success(function(e){i.deriveKey({name:s,privateKeyName:a.ecdh,publicKeyName:e}).success(function(e){t(e)})})});return u.success=function(e){return u.then(function(t){e(t)}),u},u.error=function(e){return u.then(null,function(t){e(t)}),u},u},importAndDerive:function(e,i){var a=t,o=r.ABToHS(n.getRandomValues(new Uint8Array(12))),s=r.ABToHS(n.getRandomValues(new Uint8Array(12))),u=new Promise(function(t,n){a.importKey({name:o,raw:i}).success(function(n){a.deriveKey({name:s,privateKeyName:e,publicKeyName:n}).success(function(e){t(e)})})});return u.success=function(e){return u.then(function(t){e(t)}),u},u.error=function(e){return u.then(null,function(t){e(t)}),u},u},importAndDeriveBits:function(e,i){var a=t,o=r.ABToHS(n.getRandomValues(new Uint8Array(12))),s=new Promise(function(t,n){a.importKey({name:o,raw:i}).success(function(n){a.deriveBits({privateKeyName:e,publicKeyName:n}).success(function(e){t(e)})})});return s.success=function(e){return s.then(function(t){e(t)}),s},s.error=function(e){return s.then(null,function(t){e(t)}),s},s},export:function(e){return t.exportKey({name:e})},exportDefaultKey:function(){return t.exportKey({default:!0})},encrypt:function(e,n){return t.encrypt({name:e,data:n})},decrypt:function(e,n,r){return t.decrypt({name:e,data:n,iv:r})},encryptWithDefaultKey:function(e){return t.encrypt({default:!0,data:e})},decryptWithDefaultKey:function(e,n){return t.decrypt({default:!0,data:e,iv:n})},getDefaultKeys:function(){return t.getDefaultKeys()},checkCryptoKey:function(e){return t.checkCryptoKey(e)},checkKey:function(e){return t.checkKey(e)}}}}]).factory("$httpCrypto",["$webCrypto","$http","$injector",function(e,t,n){var r=n.instantiate(NgWebCryptoUtils);return{post:function(n,i){var a=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null,s=new Promise(function(i,s){if(r.isDefined(n)||s('please define "server" in the options.'),!r.isDefined(u))var u={};r.isDefined(o)||(o=e.getDefaultKeys().crypto,r.isDefined(o)||s("default crypto key is not defined")),e.checkCryptoKey(o)||s("key "+o+" not found");var c=JSON.stringify(u);e.encrypt(o,c).success(function(u,c){var y={d:u+"."+c};t.post(n,y,a).then(function(t){var n=t.data,a=t.status,u=t.headers,c=t.config,f=t.statusText;if(!r.isDefined(n.d))return console.error("invalid crypto response from server."),void s(n);if(-1==n.d.indexOf("."))return console.error("invalid crypto response from server."),void s(n);var d=n.d.split(".")[0],p=n.d.split(".")[1];e.decrypt(o,d,p).success(function(e){try{var t=JSON.parse(e)}catch(t){return console.error("decrypted response is not json."),void s(e)}resultObj={data:t,status:a,headers:u,config:c,statusText:f,encrypted:y},i(resultObj)}).error(function(e){resultObj={data:null,status:a,headers:u,config:c,statusText:f,encrypted:y},s(resultObj)})},function(e){var t=(e.data,e.status),n=e.headers,r=e.config,i=e.statusText;resultObj={data:null,status:t,headers:n,config:r,statusText:i,encrypted:y},s(resultObj)})}).error(function(e){resultObj={data:null,status:null,headers:null,config:config,statusText:null,encrypted:null},s(resultObj)})});return s.success=function(e){return s.then(function(t){e(t.data)}),s},s.error=function(e){return s.then(null,function(t){e(t)}),s},s}}}]);
//# sourceMappingURL=ng-web-crypto.es5.min.js.map
